#pragma once

#include "GameServer/Accounts.hxx"
#include "GameServer/Appartements.hxx"
#include "GameServer/BuddyList.hxx"
#include "GameServer/Chars.hxx"
#include "GameServer/Chat.hxx"
#include "GameServer/Client.hxx"
#include "GameServer/ClientManager.hxx"
#include "GameServer/Commands.hxx"
#include "GameServer/ConfigTemplate.hxx"
#include "GameServer/Container.hxx"
#include "GameServer/DoorTemplate.hxx"
#include "GameServer/FurnitureTemplate.hxx"
#include "GameServer/GameScript.hxx"
#include "GameServer/GameServer.hxx"
#include "GameServer/GenrepList.hxx"
#include "GameServer/Inventory.hxx"
#include "GameServer/Isc.hxx"
#include "GameServer/Item.hxx"
#include "GameServer/LuaEngine.hxx"
#include "GameServer/Main.hxx"
#include "GameServer/MessageBuilder.hxx"
#include "GameServer/MultiPart.hxx"
#include "GameServer/Npc.hxx"
#include "GameServer/NpcTemplate.hxx"
#include "GameServer/Outpost.hxx"
#include "GameServer/RemoteConsole.hxx"
#include "GameServer/Server.hxx"
#include "GameServer/Skill.hxx"
#include "GameServer/Sql.hxx"
#include "GameServer/Subway.hxx"
#include "GameServer/Terminal.hxx"
#include "GameServer/Vehicle.hxx"
#include "GameServer/VehicleAccessRequest.hxx"
#include "GameServer/WorldActors.hxx"
#include "GameServer/WorldDataTemplate.hxx"
#include "GameServer/Worlds.hxx"
#include "GameServer/Zoning.hxx"

extern class PLuaEngine *LuaEngine;

extern class ServerSocket *ServerSock;
extern class PConsole *Console;
//extern class PRConsole *RemoteConsole;
extern class PConfig *Config;
extern class PConfig *CmdAccess;

extern class PGameDefs *GameDefs;
extern class PFileSystem *Filesystem;
extern class PServer *Server;

extern class PGameServer *GameServer;
extern class PChars *Chars;

extern class PMsgBuilder *MsgBuilder;
extern class PWorlds *Worlds;
extern class PAppartements* Appartements;
extern class PWorldActors* WorldActors;
extern class PTerminal* Terminal;
//extern class gmMachine machine;   // Virtual Machine instance

//multiuser chat
extern class PClientManager *ClientManager;
extern class PNPCManager* NPCManager;
extern class PChat *Chat;
extern class PCommands *GameCommands;

extern class POutpost *Outposts;
extern class PMultiPart *MultiPartHandler;

// Development debug output control
extern bool gDevDebug;

//MySQL-Support
extern class PMySQL* MySQL;

//Vehicles
extern class PVehicles *Vehicles;
extern class PSubway* Subway;

//Infoserver update
extern class PISC *ISC;

bool InitTinNS();
void Shutdown();
